﻿// For an introduction to the Navigation template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232506
(function () {
    "use strict";

    var activation = Windows.ApplicationModel.Activation;
    var app = WinJS.Application;
    var nav = WinJS.Navigation;
    var sched = WinJS.Utilities.Scheduler;
    var ui = WinJS.UI;

    app.addEventListener("activated", function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.

                /*
                // Navigate to "default" page
                nav.navigate("/pages/home/home.html");

                WinJS.Utilities.query("[data-nav$='.html']").listen("click",
                    function (e) {
                        var fname = this.getAttribute("data-nav");
                        var folder = fname.substring(0, fname.lastIndexOf("."));
                        nav.navigate("/pages/" + folder + "/" + fname);
                    });
                    */

            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }

            nav.history = app.sessionState.history || {};
            nav.history.current.initialPlaceholder = true;

            // Optimize the load of the application and while the splash screen is shown, execute high priority scheduled work.
            ui.disableAnimations();
            var p = ui.processAll().then(function () {
                return nav.navigate(nav.location || Application.navigator.home, nav.state);
            }).then(function () {
                return sched.requestDrain(sched.Priority.aboveNormal + 1);
            }).then(function () {
                ui.enableAnimations();
            });

            args.setPromise(p);

            //args.setPromise(WinJS.UI.processAll());
        }
    });

    nav.addEventListener("navigated", function (e) {
        var navBar = document.getElementById("navBar").winControl;
        navBar.hide();
    });

    /*
    nav.addEventListener("navigated", function (e) {
        var url = e.detail.location;
        var host = document.getElementById("contenthost");

        // clear out all children
        WinJS.Utilities.empty(host);

        e.detail.setPromise(
            WinJS.UI.Pages.render(url, host, e.detail.state));
    });
    */

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. If you need to 
        // complete an asynchronous operation before your application is 
        // suspended, call args.setPromise().
        app.sessionState.history = nav.history;
    };

    app.start();
})();
