﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var pickers = Windows.Storage.Pickers;

    function displayError(msg) {
        var md = Windows.UI.Popups.MessageDialog(msg, "Error");
        md.showAsync();
    };

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());
        }

        document.getElementById("pickImage").addEventListener("click", function () {
            var fp = new pickers.FileOpenPicker();
            fp.commitButtonText = "Show";
            fp.suggestedStartLocation = pickers.PickerLocationId.picturesLibrary;
            fp.viewMode = pickers.PickerViewMode.thumbnail;
            fp.fileTypeFilter.replaceAll([".png", ".jpg"]);
            
            fp.pickSingleFileAsync()
                .done(function (file) {
                    if (file) {
                        var imageUrl = URL.createObjectURL(file);
                        document.getElementById("image").src = imageUrl;
                        document.getElementById("name").innerHTML = file.name;
                        URL.revokeObjectURL(imageUrl);
                    }
                    else {
                        displayError("No image selected.");
                    }
                }, displayError);
            
        });

        document.getElementById("start").addEventListener("click", function () {
            var promise = WinJS.Promise.timeout(2000)
                .then(function () {
                    console.log("Work happens here.");
                    return 2 + 2;
                }).then(function (sum) {
                    console.log("sum is " + sum);
                }).then(null, function(error) {
                    console.log("error: " + error);
                });

            console.log("canceling promise");
            promise.cancel();
        });
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    app.start();
})();
